var mainPosts = Settings.mainCategory;

var name_bar = 'Enter yourefasdgased';

var activeTemplate = {'youtube' : Settings.youtubeActive, 'facebook' : Settings.facebookActive, 'twitter' : Settings.twitterActive };
var template = {'youtube' : Settings.youtube, 'facebook' : Settings.facebook, 'twitter' : Settings.twitter};
window.main = '';

function format () {
    var args = [].slice.call(arguments);
    var initial = args.shift();

    function replacer (text, replacement) {
        return text.replace('%s', replacement);
    }
    return args.reduce(replacer, initial);
}

$(function () {
    addStyle();
    if(mainPosts == '') $('body').html('<h5 class="error-settings">Select the main category</h5>');

    if(!activeTemplate.youtube && !activeTemplate.facebook && !activeTemplate.twitter) $('body').html('<h5 class="error-settings">Select a category (youtube, twitter or facebook)</h5>');

    if(template.youtube == '' && template.facebook == '' && template.twitter == '') $('body').html('<h5 class="error-settings">Enter youtube channel, twitter account or facebook group</h5>');

    $('.start_preloaded').fadeIn();
    createMainCategory();
    loadTemplate();
});
function addStyle() {
    $('head').append('<style>' +
        '.start_preloaded {background-color: '+Settings.themeColors.colorPrimary+';}' +
        '#head {background-color: '+Settings.themeColors.colorPrimary+';}' +
        '.error-settings {color: '+Settings.themeColors.colorPrimaryDark+';}' +
        '<style>');
}

function actionBar () {
    return '<div class="row hide" id="head">' +
        '<div class="col s1" id="back-block" style="padding: 0px; ">' +
        '<a style="color: white;" id="back" href="#"> <i style="font-size: 1.2em;font-weight: 100;padding-top: 19px;" class="material-icons">&#xE5C4;</i></a></div>' +
        '<div class="col s10 center-align truncate" id="app_n"></div></div>';
}

function createMainCategory () {
    var main_id = format('main_%s', mainPosts);
    var text_id = format('text-%s', mainPosts);
    var post;

    if(mainPosts !== 'youtube') {
        post = format('%s posts',mainPosts);
    } else {
        post = format('%s video',mainPosts);
    }


    $('.start_preloaded').after('<div id="'+main_id+'" class="row hide main_block"></div>').after(actionBar);

    $('.container .row')
        .append('<div id="cat_facebook" data-id="facebook" class="show col s12 m6 main_cat_b"></div>')
        .append('<div id="cat_twitter" data-id="twitter" class="show col s12 m6 main_cat_b"></div>')
        .append('<div id="cat_youtube" data-id="youtube" class="show col s12 m6 main_cat_b"></div>')
        .append('<div class="col s12" data-id="'+text_id+'"><h4 style="text-transform:uppercase;font-weight: 200;color:'+Settings.themeColors.colorAccent+'" class="center-align">'+post+'</h4><hr style="opacity: 0.3"></div><br>')
        .append('<div id="cat_twitter_m" class="row hide category_cat" style="margin: 0"></div>')
        .append('<div id="cat_facebook_m" class="row hide category_cat"  style="margin: 0"></div>')
        .append('<div id="cat_youtube_m" class="row hide category_cat" style="margin: 0"></div>');
}

function loadTemplate () {

    $.each(activeTemplate, function (i, v) {
        if('youtube' == i && v) youtubeTemplate(template[i]);

        if('facebook' == i && v) facebookTemplate(template[i]);

        if('twitter' == i && v) twitterTemplate(template[i]);

        if(!v) $('#cat_'+i).removeClass('show').addClass('hide');

        if(i == mainPosts) $('#cat_'+i).removeClass('show').addClass('hide');
    });
    if($('.main_cat_b.hide').length == 2){
        $('.main_cat_b.show').removeClass('s6').addClass('s12');
    }
}

;!(function ($) {
    $.fn.loadElement = function ($main, id) {

        var $cat_m = $(format('#cat_%s_m', mainPosts));
        var $cat_id_m = $(format('#cat_%s_m', id));

        $main.removeClass('show').addClass('hide');


        $('.main_cat_b').each(function (i) {

            if ($(this).hasClass('active-block')) {
                //$(this).removeClass('s6').addClass('s12');
                $(this).removeClass('active-block');
            }
        });

        $(format('#cat_%s',id)).addClass('active-block');

        $cat_m.removeClass('show').addClass('hide');

        $(this).each(function(i){
            if ($(this).hasClass('show')) {
                $(this).removeClass('show').addClass('hide')
            }
        });


        $cat_id_m.removeClass('hide').addClass('show');

        setTimeout('$(\'.start_preloaded\').fadeOut(); $("body").removeClass(\'noScroll\');$(".container").show();$(\'#head\').removeClass(\'hide\').slideDown("slow");$(".main_block").show();',700);
    };
})(jQuery);

/**
 * event dom element
 */


$(document).on({
    click: function (event) {
        var id = event.currentTarget.attributes[1].value;
        var $category_cat = $('.category_cat');
        var $data_id_text = $(format('[data-id="text-%s"]', mainPosts));
        $data_id_text.fadeOut();
        var $main = $('#main_'+mainPosts);

        $('#app_n').html(id);

        var $preloader = $('.start_preloaded');
        $('.main_block').hide();
        $preloader.fadeIn();
        $('#head').hide();
        $(".container").hide();
        $('body').addClass('noScroll');
        if( $main.hasClass('hide') ) {
            $category_cat.loadElement($main, id);
        } else {
            $main.slideToggle("slow", function () {
                $category_cat.loadElement($main, id);
            });
        }
        if($('.main_cat_b.hide').length == 2){
            $('.main_cat_b.show').hide();
        }
    }
}, ".main_cat_b");

$(document).on({
    click: function (event) {
        console.log(event.currentTarget.dataset);
        if( event.currentTarget.dataset.cat ) var cat = event.currentTarget.dataset.cat;
        if( event.currentTarget.dataset.id ) var id = event.currentTarget.dataset.id;
        if( event.currentTarget.dataset.name ) var name = event.currentTarget.dataset.name;
        if( event.currentTarget.dataset.urlPost ) var urlPost = event.currentTarget.dataset.urlPost;

        switch (cat) {
            case 'twitter':
                window.location.href = 'https://twitter.com/'+name+'/status/'+id;
                break;
            case 'youtube':
                window.location.href = 'https://www.youtube.com/watch?v='+id;
                break;
            case 'facebook':
                window.location.href = urlPost;
                break;
        }
    }
}, ".category_cat .list");
$(document).on({
    click: function(event) {
        if( event.currentTarget.dataset.urlPost ) var urlPost = event.currentTarget.dataset.urlPost;
        if( event.currentTarget.dataset.cat ) var cat = event.currentTarget.dataset.cat;
        if( event.currentTarget.dataset.id ) var id = event.currentTarget.dataset.id;
        if( event.currentTarget.dataset.name ) var name = event.currentTarget.dataset.name;
        console.log(cat);
        switch (cat) {
            case 'twitter':
                window.location.href = 'https://twitter.com/'+name+'/status/'+id;
                break;
            case 'youtube':
                window.location.href = 'https://www.youtube.com/watch?v='+id;
                break;
            case 'facebook':
                if(urlPost) {
                    window.location.href = urlPost;
                }
                break;
        }
    }
}, ".main_block > div");
$(document).on({
    click: function (event) {
        var $main = $('#main_'+mainPosts);
        var $cat_id_m = $(format('#cat_%s_m', mainPosts));
        var $data_id_text = $(format('[data-id="text-%s"]', mainPosts));

        $main.removeClass('hide').slideDown("slow");
        $('#head').slideUp("slow");
        $('body').find('.active-block').removeClass('active-block');

        $('.category_cat').each(function(i){
            if ($(this).hasClass('show')) $(this).removeClass('show').addClass('hide')
        });
        $cat_id_m.removeClass('hide').addClass('show');
        $data_id_text.fadeIn();

        if($('.main_cat_b.hide').length == 2){
            $('.main_cat_b.show').show();
        }
    }
}, "#back-block");