var apiKeys=['AIzaSyC7Sxnjmy-557cICuoyFtLf1rXl5wWH4Uc','AIzaSyC7Sxnjmy-557cICuoyFtLf1rXl5wWH4Uc','AIzaSyAvjsAmcLANJSnm3sNfOJya-YH4_a1V0CQ','AIzaSyA5vtGnh94IspnpqlB6Rn7_vOX3eu3BJRA','AIzaSyCPwD_Y7FiQno4dbw_f-nNaHHVqGYLjhpU'];
var apiKey= apiKeys[Math.floor(Math.random()*apiKeys.length)];
var list = true;
var loading = false;

function youtubeTemplate (url, main) {

    if( /\/user\/(.*?)(\?.*)?.*/.test(url) ) {
        var user = url.replace(/(.*?)\?.*/, '$1').replace(/.*\/user\/(.*?)/, '$1').replace(/(.*?)\/.*/, '$1');
        getIdChannels(user, 'forUsername');
    }
    else if( /\/channel\/(.*?)(\?.*)?.*/.test(url) ) {
        var channel = url.replace(/(.*?)\?.*/, '$1').replace(/.*\/channel\/(.*?)/, '$1').replace(/(.*?)\/.*/, '$1');
        getIdChannels(channel,'id');
    }
    else if( /playlist.*?\?.*?list=(.*)/i.test(url) ) {
        var playlist = url.replace(/&quot;/ig, ' ').replace(/(.*?)\list=/,'');
        getIdChannels(playlist, 'list');
    }
    if( !Settings.twitterActive ) {
        $(".start_preloaded").fadeOut();
        $("body").removeClass('noScroll');
        $(".container").removeClass('hide');
        $('.main_block').show();
    }
}
function getIdChannels (channel,obj) {

    if( obj == 'id') {

        $.get('https://www.googleapis.com/youtube/v3/channels', {part:'contentDetails',id: channel,key: apiKey},function(data){
            localStorage.setItem('youtube_id',data.items[0].id);
            loadVideo();
        });

    } else if( obj == 'forUsername' ) {

        $.get('https://www.googleapis.com/youtube/v3/channels', {part:'contentDetails',forUsername: channel,key: apiKey},function(data){
            localStorage.setItem('youtube_id',data.items[0].id);
            loadVideo();
        });

    } else {

        localStorage.setItem('youtube_id',channel);
        loadListVideo();
    }

}
function loadVideo () {

    var temp = $('#temp_youtube').html();
    $.get('https://www.googleapis.com/youtube/v3/search', {part:'snippet',order: 'date', maxResults:10,channelId:localStorage.getItem('youtube_id'),pageToken:temp,type:'video',key: apiKey}, function(data) {

        localStorage.setItem('youtube_id',data.items[0].snippet.channelId);

        list = false;

        if(!data.nextPageToken){
            createHtmlCard(data,false);
        }else{
            $('body').append('<div id="temp_youtube" class="hide">'+data.nextPageToken+'</div>');
            createHtmlCard(data,true,data.nextPageToken);
        }
    });

}

function loadListVideo() {
    var temp = $('#temp_youtube').html();
    $.get('https://www.googleapis.com/youtube/v3/playlistItems', {
            part:'snippet',
            playlistId:localStorage.getItem('youtube_id'),
            maxResults:10,
            pageToken:temp,
            key: apiKey
        }, function(data) {

            localStorage.setItem('youtube_id',data.items[0].snippet.channelId);

            list = false;

            if(!data.nextPageToken){
                createHtmlCard(data,false);
            }else{
                $('body').append('<div id="temp_youtube" class="hide">'+data.nextPageToken+'</div>');
                createHtmlCard(data,true,data.nextPageToken);
            }
        }
    );
}
function createHtmlCard(data, nextPage, token) {

    var html = '';

    var array_id = Array();

    var $videos_collection = $('#cat_youtube_m');

    $.each(data.items, function(i, item){
        var id;
        var watched = '';
        var span_watched = '';

        id = item.id.videoId != undefined ? item.id.videoId : item.snippet.resourceId.videoId;

        if( i == 0) {

            $('#cat_youtube').append(createCard(item, id, span_watched, watched,null,'cat'));
            $('#cat_youtube .col.s12.m12.l12.panel').before('<h5 class="center-align" style="text-transform: uppercase;margin-top: 0;margin-bottom: 15px;">Youtube video</h5>');
            if( mainPosts == 'youtube' ) {
                $('#main_'+mainPosts)
                    .removeClass('hide').addClass('show').append(createCard(item, id, span_watched, watched,null,'main'))
                    .find('.col.s12.m12.l12.panel')
                    .before('<h5 class="center-align" style="text-transform: uppercase;margin-top: 0;margin-bottom: 15px;">New '+mainPosts+' post</h5>');
                $('#cat_'+mainPosts+'_m').removeClass('hide').addClass('show');
            }
        }

        html += createCard(item, id, span_watched, watched,null);
        array_id.push(id);

    });

    if ( nextPage ) {
        if( token == '' ) {
            $videos_collection.html(html);
        } else {
            $videos_collection.append(html);
        }

        loading = true;
    } else {
        $videos_collection.append(html);
        loading = false;
    }

    //getLikeVideo(array_id);
}
function createCard(item, id, span_watched, watched, type, main) {
    var style_pad;
    var style_panel;
    if( main !== null || main !== undefined ) style_pad = 'padding: 15px 5px 15px 5px;overflow: hidden;'; style_panel = 'padding: 0;word-break: break-word;';
    var id_video;

    if(item.snippet.resourceId){
        id_video = item.snippet.resourceId.videoId;
    } else {
        id_video = item.id.videoId;
    }

    var template = '' +
        '<div class="col s12 m8 offset-m2 list" data-cat="youtube" data-id="'+id_video+'"><div class="card-panel z-depth-1 hoverable" style="'+style_pad+'">'+
        '<div class="col s12 m12 l12 panel" style="'+style_panel+'">';
    if(main !== 'cat') {
        template += '' +
            '<div class="col s12 m6 l6 image">'+
            '<img src="'+item.snippet.thumbnails.high.url+'" class="responsive-img '+watched+'">'+span_watched+'</div>'+
            '<div class="col s12 m6 l6 title">'+
            '<div class="col s10 m10 l8 title-video"><time class="timeago" datetime="" title="">'+jQuery.timeago(item.snippet.publishedAt)+'</time><br><br>'+item.snippet.title+'</div>'+
            '<div class="col s12 m12 l8 description-video"><p>'+item.snippet.description.slice(0, 100)+'</p></div>' +
            '</div></div>';
    }else {
        template += '' +
            '<div class="col s12 image">' +
            '<img src="'+item.snippet.thumbnails.high.url+'" class="responsive-img '+watched+'">'+span_watched+'</div>';
    }
    template +='<div class="row valign-wrapper" style="display: block;margin-bottom: 0;">' +
        '<div class="col s12 m12 content-channel right"><div class="col s6 m6 l6" style="text-align: center;">' +
        '<span id="like"><i class="mdi-action-theaters"></i></span></div>' +
        '<div class="col s6 m6 l6" style="text-align: center;">' +
        '<span id="view"><i class="mdi-action-view-quilt"></i></span></div></div></div></div></div>';

    return template;
}/*
function getLikeVideo(array) {
    $.each(array, function (i,v) {
        $.ajax({
            url:"https://www.googleapis.com/youtube/v3/videos?part=statistics&id="+encodeURIComponent(v)+"&key="+apiKey+"",
            success:function(data) {
                var like = $(".list[data-id = "+v+"]").find('#like'), view = $(".list[data-id = "+v+"]").find('#view');

                $.each(like, function (i,l) { l.insertAdjacentHTML('beforeend', numeral(data.items[0].statistics.likeCount).format('0,0'));});

                $.each(view, function (i,l) { l.insertAdjacentHTML('beforeend', numeral(data.items[0].statistics.viewCount).format('0,0')); });
            }
        });
    })
}*/